# Class HttpRetryException

java.lang.Object
java.lang.Throwable
java.lang.Exception
java.io.IOException
java.net.HttpRetryException

All Implemented Interfaces:
  `Serializable`

public class HttpRetryException extends IOException
Thrown to indicate that a HTTP request needs to be retried but cannot be retried automatically, due to streaming mode being enabled.

Since:
  1.5
See Also:
  - Serialized Form

## Constructor Summary

Constructors
Constructor
Description
`HttpRetryException(String detail, int code)`
Constructs a new `HttpRetryException` from the specified response code and exception detail message
`HttpRetryException(String detail, int code, String location)`
Constructs a new `HttpRetryException` with detail message responseCode and the contents of the Location response header field.

## Method Summary

Modifier and Type
Method
Description
`String`
`getLocation()`
Returns the value of the Location header field if the error resulted from redirection.
`String`
`getReason()`
Returns a string explaining why the http request could not be retried.
`int`
`responseCode()`
Returns the http response code

### Methods declared in class Throwable

`addSuppressed, fillInStackTrace, getCause, getLocalizedMessage, getMessage, getStackTrace, getSuppressed, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString`
Modifier and Type
Method
Description
`final void`
`addSuppressed(Throwable exception)`
Appends the specified exception to the exceptions that were suppressed in order to deliver this exception.
`Throwable`
`fillInStackTrace()`
Fills in the execution stack trace.
`Throwable`
`getCause()`
Returns the cause of this throwable or `null` if the cause is nonexistent or unknown.
`String`
`getLocalizedMessage()`
Creates a localized description of this throwable.
`String`
`getMessage()`
Returns the detail message string of this throwable.
`StackTraceElement[]`
`getStackTrace()`
Provides programmatic access to the stack trace information printed by `Throwable.printStackTrace()`.
`final Throwable[]`
`getSuppressed()`
Returns an array containing all of the exceptions that were suppressed, typically by the `try`-with-resources statement, in order to deliver this exception.
`Throwable`
`initCause(Throwable cause)`
Initializes the cause of this throwable to the specified value.
`void`
`printStackTrace()`
Prints this throwable and its backtrace to the standard error stream.
`void`
`printStackTrace(PrintStream s)`
Prints this throwable and its backtrace to the specified print stream.
`void`
`printStackTrace(PrintWriter s)`
Prints this throwable and its backtrace to the specified print writer.
`void`
`setStackTrace(StackTraceElement[] stackTrace)`
Sets the stack trace elements that will be returned by `Throwable.getStackTrace()` and printed by `Throwable.printStackTrace()` and related methods.
`String`
`toString()`
Returns a short description of this throwable.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Constructor Details

### HttpRetryException

public HttpRetryException(String detail, int code)
Constructs a new `HttpRetryException` from the specified response code and exception detail message

Parameters:
  `detail` - the detail message.
  `code` - the HTTP response code from server.

### HttpRetryException

public HttpRetryException(String detail, int code, String location)
Constructs a new `HttpRetryException` with detail message responseCode and the contents of the Location response header field.

Parameters:
  `detail` - the detail message.
  `code` - the HTTP response code from server.
  `location` - the URL to be redirected to

## Method Details

### responseCode

public int responseCode()
Returns the http response code

Returns:
  The http response code.

### getReason

public String getReason()
Returns a string explaining why the http request could not be retried.

Returns:
  The reason string

### getLocation

public String getLocation()
Returns the value of the Location header field if the error resulted from redirection.

Returns:
  The location string